/* Generated from defs.json. Do not edit!  */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <ocispec/read-file.h>
#include "ocispec/runtime_spec_schema_defs.h"

define_cleaner_function (runtime_spec_schema_defs_hook *, free_runtime_spec_schema_defs_hook)
runtime_spec_schema_defs_hook *
make_runtime_spec_schema_defs_hook (json_t *tree, const struct parser_context *ctx, parser_error *err)
{
    __auto_cleanup(free_runtime_spec_schema_defs_hook) runtime_spec_schema_defs_hook *ret = NULL;
    *err = NULL;
    (void) ctx;  /* Silence compiler warning.  */
    if (tree == NULL)
      return NULL;
    if (json_is_null(tree))
      return NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    do
      {
        const json_t *val = json_object_get (tree, "path");
        if (val != NULL)
          {
            const char *str = json_string_value (val);
            ret->path = strdup (str ? str : "");
            if (ret->path == NULL)
              return NULL;
          }
      }
    while (0);
    do
      {
       json_t *tmp = json_object_get (tree, "args");
        if (tmp != NULL &&  !json_is_null(tmp))
          {
            size_t i;
            json_t *value;
            size_t len = json_array_size(tmp);
            ret->args_len = len;
            ret->args = calloc (len + 1, sizeof (*ret->args));
            if (ret->args == NULL)
              return NULL;
            json_array_foreach(tmp, i, value)
              {
                const json_t *val = value;
                if (val != NULL)
                  {
                    const char *str = json_string_value (val);
                    ret->args[i] = strdup (str ? str : "");
                    if (ret->args[i] == NULL)
                      return NULL;
                  }
              }
        }
      }
    while (0);
    do
      {
       json_t *tmp = json_object_get (tree, "env");
        if (tmp != NULL &&  !json_is_null(tmp))
          {
            size_t i;
            json_t *value;
            size_t len = json_array_size(tmp);
            ret->env_len = len;
            ret->env = calloc (len + 1, sizeof (*ret->env));
            if (ret->env == NULL)
              return NULL;
            json_array_foreach(tmp, i, value)
              {
                const json_t *val = value;
                if (val != NULL)
                  {
                    const char *str = json_string_value (val);
                    ret->env[i] = strdup (str ? str : "");
                    if (ret->env[i] == NULL)
                      return NULL;
                  }
              }
        }
      }
    while (0);
    do
      {
        const json_t *val = json_object_get (tree, "timeout");
        if (val != NULL)
          {
            int invalid;
            if (!json_is_number (val))
              {
                *err = strdup ("invalid type");
                return NULL;
              }
            invalid = json_double_to_int (json_number_value(val), (int *)&ret->timeout);
            if (invalid)
              {
                if (asprintf (err, "Invalid value '%f' with type 'integer' for key 'timeout': %s", json_number_value (val), strerror (-invalid)) < 0)
                    *err = strdup ("error allocating memory");
                return NULL;
            }
            ret->timeout_present = 1;
        }
      }
    while (0);
    if (ret->path == NULL)
      {
        if (asprintf (err, "Required field '%s' not present",  "path") < 0)
            *err = strdup ("error allocating memory");
        return NULL;
      }

    if (json_is_object(tree))
      {
        if (ctx->options & OPT_PARSE_FULLKEY)
          {
            if (tree == NULL)
                return NULL;
          }
        int len = 4;
const char *excluded[] = {"path", "args", "env", "timeout"};
        json_t *resi = copy_unmatched_fields(tree, excluded, len);

        size_t resilen = json_object_size(resi);

        if (ctx->options & OPT_PARSE_FULLKEY && resi != NULL && resilen > 0)
          ret->_residual = resi;
      }
    return move_ptr (ret);
}

void
free_runtime_spec_schema_defs_hook (runtime_spec_schema_defs_hook *ptr)
{
    if (ptr == NULL)
        return;
    free (ptr->path);
    ptr->path = NULL;
    if (ptr->args != NULL)
      {
        size_t i;
        for (i = 0; i < ptr->args_len; i++)
          {
            if (ptr->args[i] != NULL)
              {
                free (ptr->args[i]);
                ptr->args[i] = NULL;
              }
          }
        free (ptr->args);
        ptr->args = NULL;
    }
    if (ptr->env != NULL)
      {
        size_t i;
        for (i = 0; i < ptr->env_len; i++)
          {
            if (ptr->env[i] != NULL)
              {
                free (ptr->env[i]);
                ptr->env[i] = NULL;
              }
          }
        free (ptr->env);
        ptr->env = NULL;
    }
    json_decref (ptr->_residual);
    ptr->_residual = NULL;
    free (ptr);
}

int
gen_runtime_spec_schema_defs_hook (json_t *root, const runtime_spec_schema_defs_hook *ptr, parser_error *err)
{
    int stat = JSON_GEN_SUCCESS;
    /* Handle cases where root is not used within body of function */
    if (json_is_null(root))
         return stat;
    *err = NULL;
    (void) ptr;  /* Silence compiler warning.  */
    if (ptr != NULL && ptr->path != NULL)
      {
        stat = json_object_set(root, (const char *)("path"), json_string(ptr->path));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->args != NULL)
      {
        size_t len = 0, i;
        json_t *subroot = json_array();
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
        if (ptr != NULL && ptr->args != NULL)
          len = ptr->args_len;
        for (i = 0; i < len; i++)
          {
            stat = json_array_append(subroot, json_string(ptr->args[i]));
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
          }
     stat =  json_object_set(root, (const char *)("args"), subroot);
   }
    if (ptr != NULL && ptr->env != NULL)
      {
        size_t len = 0, i;
        json_t *subroot = json_array();
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
        if (ptr != NULL && ptr->env != NULL)
          len = ptr->env_len;
        for (i = 0; i < len; i++)
          {
            stat = json_array_append(subroot, json_string(ptr->env[i]));
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
          }
     stat =  json_object_set(root, (const char *)("env"), subroot);
   }
    if (ptr != NULL && ptr->timeout_present)
      {
       json_int_t num = 0;
       if (ptr != NULL && ptr->timeout)
            num = (json_int_t)ptr->timeout;
        stat =  json_object_set(root, (const char *)("timeout"), json_integer(num));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->_residual != NULL)
      {
        stat = json_object_update_missing(root, ptr->_residual);
        if (JSON_GEN_SUCCESS != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    return JSON_GEN_SUCCESS;
}

runtime_spec_schema_defs_hook *
clone_runtime_spec_schema_defs_hook (runtime_spec_schema_defs_hook *src)
{
    (void) src;  /* Silence compiler warning.  */
    __auto_cleanup(free_runtime_spec_schema_defs_hook) runtime_spec_schema_defs_hook *ret = NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    if (src->path)
      {
        ret->path = strdup (src->path);
        if (ret->path == NULL)
          return NULL;
      }
    if (src->args)
      {
        ret->args_len = src->args_len;
        ret->args = calloc (src->args_len + 1, sizeof (*ret->args));
        if (ret->args == NULL)
          return NULL;
        for (size_t i = 0; i < src->args_len; i++)
          {
            if (src->args[i])
              {
                ret->args[i] = strdup (src->args[i]);
                if (ret->args[i] == NULL)
                  return NULL;
              }
          }
      }
    if (src->env)
      {
        ret->env_len = src->env_len;
        ret->env = calloc (src->env_len + 1, sizeof (*ret->env));
        if (ret->env == NULL)
          return NULL;
        for (size_t i = 0; i < src->env_len; i++)
          {
            if (src->env[i])
              {
                ret->env[i] = strdup (src->env[i]);
                if (ret->env[i] == NULL)
                  return NULL;
              }
          }
      }
    ret->timeout = src->timeout;
    ret->timeout_present = src->timeout_present;
    return move_ptr (ret);
}

define_cleaner_function (runtime_spec_schema_defs_id_mapping *, free_runtime_spec_schema_defs_id_mapping)
runtime_spec_schema_defs_id_mapping *
make_runtime_spec_schema_defs_id_mapping (json_t *tree, const struct parser_context *ctx, parser_error *err)
{
    __auto_cleanup(free_runtime_spec_schema_defs_id_mapping) runtime_spec_schema_defs_id_mapping *ret = NULL;
    *err = NULL;
    (void) ctx;  /* Silence compiler warning.  */
    if (tree == NULL)
      return NULL;
    if (json_is_null(tree))
      return NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    do
      {
        const json_t *val = json_object_get (tree, "containerID");
        if (val != NULL)
          {
            int invalid;
            if (!json_is_number (val))
              {
                *err = strdup ("invalid type");
                return NULL;
              }
            invalid = json_double_to_uint32 (json_number_value(val), &ret->container_id);
            if (invalid)
              {
                if (asprintf (err, "Invalid value '%f' with type 'uint32' for key 'containerID': %s", json_number_value (val), strerror (-invalid)) < 0)
                    *err = strdup ("error allocating memory");
                return NULL;
            }
            ret->container_id_present = 1;
        }
      }
    while (0);
    do
      {
        const json_t *val = json_object_get (tree, "hostID");
        if (val != NULL)
          {
            int invalid;
            if (!json_is_number (val))
              {
                *err = strdup ("invalid type");
                return NULL;
              }
            invalid = json_double_to_uint32 (json_number_value(val), &ret->host_id);
            if (invalid)
              {
                if (asprintf (err, "Invalid value '%f' with type 'uint32' for key 'hostID': %s", json_number_value (val), strerror (-invalid)) < 0)
                    *err = strdup ("error allocating memory");
                return NULL;
            }
            ret->host_id_present = 1;
        }
      }
    while (0);
    do
      {
        const json_t *val = json_object_get (tree, "size");
        if (val != NULL)
          {
            int invalid;
            if (!json_is_number (val))
              {
                *err = strdup ("invalid type");
                return NULL;
              }
            invalid = json_double_to_uint32 (json_number_value(val), &ret->size);
            if (invalid)
              {
                if (asprintf (err, "Invalid value '%f' with type 'uint32' for key 'size': %s", json_number_value (val), strerror (-invalid)) < 0)
                    *err = strdup ("error allocating memory");
                return NULL;
            }
            ret->size_present = 1;
        }
      }
    while (0);

    if (json_is_object(tree))
      {
        if (ctx->options & OPT_PARSE_FULLKEY)
          {
            if (tree == NULL)
                return NULL;
          }
        int len = 3;
const char *excluded[] = {"containerID", "hostID", "size"};
        json_t *resi = copy_unmatched_fields(tree, excluded, len);

        size_t resilen = json_object_size(resi);

        if (ctx->options & OPT_PARSE_FULLKEY && resi != NULL && resilen > 0)
          ret->_residual = resi;
      }
    return move_ptr (ret);
}

void
free_runtime_spec_schema_defs_id_mapping (runtime_spec_schema_defs_id_mapping *ptr)
{
    if (ptr == NULL)
        return;
    json_decref (ptr->_residual);
    ptr->_residual = NULL;
    free (ptr);
}

int
gen_runtime_spec_schema_defs_id_mapping (json_t *root, const runtime_spec_schema_defs_id_mapping *ptr, parser_error *err)
{
    int stat = JSON_GEN_SUCCESS;
    /* Handle cases where root is not used within body of function */
    if (json_is_null(root))
         return stat;
    *err = NULL;
    (void) ptr;  /* Silence compiler warning.  */
    if (ptr != NULL && ptr->container_id_present)
      {
       json_int_t num = 0;
       if (ptr != NULL && ptr->container_id)
            num = (json_int_t)ptr->container_id;
        stat =  json_object_set(root, (const char *)("containerID"), json_integer(num));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->host_id_present)
      {
       json_int_t num = 0;
       if (ptr != NULL && ptr->host_id)
            num = (json_int_t)ptr->host_id;
        stat =  json_object_set(root, (const char *)("hostID"), json_integer(num));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->size_present)
      {
       json_int_t num = 0;
       if (ptr != NULL && ptr->size)
            num = (json_int_t)ptr->size;
        stat =  json_object_set(root, (const char *)("size"), json_integer(num));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->_residual != NULL)
      {
        stat = json_object_update_missing(root, ptr->_residual);
        if (JSON_GEN_SUCCESS != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    return JSON_GEN_SUCCESS;
}

runtime_spec_schema_defs_id_mapping *
clone_runtime_spec_schema_defs_id_mapping (runtime_spec_schema_defs_id_mapping *src)
{
    (void) src;  /* Silence compiler warning.  */
    __auto_cleanup(free_runtime_spec_schema_defs_id_mapping) runtime_spec_schema_defs_id_mapping *ret = NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    ret->container_id = src->container_id;
    ret->container_id_present = src->container_id_present;
    ret->host_id = src->host_id;
    ret->host_id_present = src->host_id_present;
    ret->size = src->size;
    ret->size_present = src->size_present;
    return move_ptr (ret);
}

define_cleaner_function (runtime_spec_schema_defs_mount *, free_runtime_spec_schema_defs_mount)
runtime_spec_schema_defs_mount *
make_runtime_spec_schema_defs_mount (json_t *tree, const struct parser_context *ctx, parser_error *err)
{
    __auto_cleanup(free_runtime_spec_schema_defs_mount) runtime_spec_schema_defs_mount *ret = NULL;
    *err = NULL;
    (void) ctx;  /* Silence compiler warning.  */
    if (tree == NULL)
      return NULL;
    if (json_is_null(tree))
      return NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    do
      {
        const json_t *val = json_object_get (tree, "source");
        if (val != NULL)
          {
            const char *str = json_string_value (val);
            ret->source = strdup (str ? str : "");
            if (ret->source == NULL)
              return NULL;
          }
      }
    while (0);
    do
      {
        const json_t *val = json_object_get (tree, "destination");
        if (val != NULL)
          {
            const char *str = json_string_value (val);
            ret->destination = strdup (str ? str : "");
            if (ret->destination == NULL)
              return NULL;
          }
      }
    while (0);
    do
      {
       json_t *tmp = json_object_get (tree, "options");
        if (tmp != NULL &&  !json_is_null(tmp))
          {
            size_t i;
            json_t *value;
            size_t len = json_array_size(tmp);
            ret->options_len = len;
            ret->options = calloc (len + 1, sizeof (*ret->options));
            if (ret->options == NULL)
              return NULL;
            json_array_foreach(tmp, i, value)
              {
                const json_t *val = value;
                if (val != NULL)
                  {
                    const char *str = json_string_value (val);
                    ret->options[i] = strdup (str ? str : "");
                    if (ret->options[i] == NULL)
                      return NULL;
                  }
              }
        }
      }
    while (0);
    do
      {
        const json_t *val = json_object_get (tree, "type");
        if (val != NULL)
          {
            const char *str = json_string_value (val);
            ret->type = strdup (str ? str : "");
            if (ret->type == NULL)
              return NULL;
          }
      }
    while (0);
    do
      {
       json_t *tmp = json_object_get (tree, "uidMappings");
        if (tmp != NULL && json_is_array(tmp))
          {
            size_t len = json_array_size (tmp);
            ret->uid_mappings_len = len;
            ret->uid_mappings = calloc (len + 1, sizeof (*ret->uid_mappings));
            if (ret->uid_mappings == NULL)
              return NULL;
             json_t *value;
             size_t i;
            json_array_foreach(tmp, i, value)
              {
                ret->uid_mappings[i] = make_runtime_spec_schema_defs_id_mapping (value, ctx, err);
                if (ret->uid_mappings[i] == NULL)
                  return NULL;
              }
          }
      }
    while (0);
    do
      {
       json_t *tmp = json_object_get (tree, "gidMappings");
        if (tmp != NULL && json_is_array(tmp))
          {
            size_t len = json_array_size (tmp);
            ret->gid_mappings_len = len;
            ret->gid_mappings = calloc (len + 1, sizeof (*ret->gid_mappings));
            if (ret->gid_mappings == NULL)
              return NULL;
             json_t *value;
             size_t i;
            json_array_foreach(tmp, i, value)
              {
                ret->gid_mappings[i] = make_runtime_spec_schema_defs_id_mapping (value, ctx, err);
                if (ret->gid_mappings[i] == NULL)
                  return NULL;
              }
          }
      }
    while (0);
    if (ret->destination == NULL)
      {
        if (asprintf (err, "Required field '%s' not present",  "destination") < 0)
            *err = strdup ("error allocating memory");
        return NULL;
      }

    if (json_is_object(tree))
      {
        if (ctx->options & OPT_PARSE_FULLKEY)
          {
            if (tree == NULL)
                return NULL;
          }
        int len = 6;
const char *excluded[] = {"source", "destination", "options", "type", "uidMappings", "gidMappings"};
        json_t *resi = copy_unmatched_fields(tree, excluded, len);

        size_t resilen = json_object_size(resi);

        if (ctx->options & OPT_PARSE_FULLKEY && resi != NULL && resilen > 0)
          ret->_residual = resi;
      }
    return move_ptr (ret);
}

void
free_runtime_spec_schema_defs_mount (runtime_spec_schema_defs_mount *ptr)
{
    if (ptr == NULL)
        return;
    free (ptr->source);
    ptr->source = NULL;
    free (ptr->destination);
    ptr->destination = NULL;
    if (ptr->options != NULL)
      {
        size_t i;
        for (i = 0; i < ptr->options_len; i++)
          {
            if (ptr->options[i] != NULL)
              {
                free (ptr->options[i]);
                ptr->options[i] = NULL;
              }
          }
        free (ptr->options);
        ptr->options = NULL;
    }
    free (ptr->type);
    ptr->type = NULL;
    if (ptr->uid_mappings != NULL)      {
        size_t i;
        for (i = 0; i < ptr->uid_mappings_len; i++)
          {
          if (ptr->uid_mappings[i] != NULL)
            {
              free_runtime_spec_schema_defs_id_mapping (ptr->uid_mappings[i]);
              ptr->uid_mappings[i] = NULL;
            }
          }
        free (ptr->uid_mappings);
        ptr->uid_mappings = NULL;
      }
    if (ptr->gid_mappings != NULL)      {
        size_t i;
        for (i = 0; i < ptr->gid_mappings_len; i++)
          {
          if (ptr->gid_mappings[i] != NULL)
            {
              free_runtime_spec_schema_defs_id_mapping (ptr->gid_mappings[i]);
              ptr->gid_mappings[i] = NULL;
            }
          }
        free (ptr->gid_mappings);
        ptr->gid_mappings = NULL;
      }
    json_decref (ptr->_residual);
    ptr->_residual = NULL;
    free (ptr);
}

int
gen_runtime_spec_schema_defs_mount (json_t *root, const runtime_spec_schema_defs_mount *ptr, parser_error *err)
{
    int stat = JSON_GEN_SUCCESS;
    /* Handle cases where root is not used within body of function */
    if (json_is_null(root))
         return stat;
    *err = NULL;
    (void) ptr;  /* Silence compiler warning.  */
    if (ptr != NULL && ptr->source != NULL)
      {
        stat = json_object_set(root, (const char *)("source"), json_string(ptr->source));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->destination != NULL)
      {
        stat = json_object_set(root, (const char *)("destination"), json_string(ptr->destination));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->options != NULL)
      {
        size_t len = 0, i;
        json_t *subroot = json_array();
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
        if (ptr != NULL && ptr->options != NULL)
          len = ptr->options_len;
        for (i = 0; i < len; i++)
          {
            stat = json_array_append(subroot, json_string(ptr->options[i]));
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
          }
     stat =  json_object_set(root, (const char *)("options"), subroot);
   }
    if (ptr != NULL && ptr->type != NULL)
      {
        stat = json_object_set(root, (const char *)("type"), json_string(ptr->type));
        if (stat != JSON_GEN_SUCCESS)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    if (ptr != NULL && ptr->uid_mappings != NULL)
      {
        size_t len = 0, i;
        if (ptr != NULL && ptr->uid_mappings != NULL)
            len = ptr->uid_mappings_len;//[name:(mount_uid_mappings_container_id) type:(uint32), name:(mount_uid_mappings_host_id) type:(uint32), name:(mount_uid_mappings_size) type:(uint32)]
        json_t *subroot = json_array();
        for (i = 0; i < len; i++)
          {
            json_t *obj = json_object();
            stat = gen_runtime_spec_schema_defs_id_mapping (obj, ptr->uid_mappings[i], err);
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
            stat = json_array_append(subroot, obj);
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
          }
         stat = json_object_set(root, (const char *)("uidMappings"), subroot);
      }
    if (ptr != NULL && ptr->gid_mappings != NULL)
      {
        size_t len = 0, i;
        if (ptr != NULL && ptr->gid_mappings != NULL)
            len = ptr->gid_mappings_len;//[name:(mount_gid_mappings_container_id) type:(uint32), name:(mount_gid_mappings_host_id) type:(uint32), name:(mount_gid_mappings_size) type:(uint32)]
        json_t *subroot = json_array();
        for (i = 0; i < len; i++)
          {
            json_t *obj = json_object();
            stat = gen_runtime_spec_schema_defs_id_mapping (obj, ptr->gid_mappings[i], err);
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
            stat = json_array_append(subroot, obj);
            if (stat != JSON_GEN_SUCCESS)
                GEN_SET_ERROR_AND_RETURN (stat, err);
          }
         stat = json_object_set(root, (const char *)("gidMappings"), subroot);
      }
    if (ptr != NULL && ptr->_residual != NULL)
      {
        stat = json_object_update_missing(root, ptr->_residual);
        if (JSON_GEN_SUCCESS != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
      }
    return JSON_GEN_SUCCESS;
}

runtime_spec_schema_defs_mount *
clone_runtime_spec_schema_defs_mount (runtime_spec_schema_defs_mount *src)
{
    (void) src;  /* Silence compiler warning.  */
    __auto_cleanup(free_runtime_spec_schema_defs_mount) runtime_spec_schema_defs_mount *ret = NULL;
    ret = calloc (1, sizeof (*ret));
    if (ret == NULL)
      return NULL;
    if (src->source)
      {
        ret->source = strdup (src->source);
        if (ret->source == NULL)
          return NULL;
      }
    if (src->destination)
      {
        ret->destination = strdup (src->destination);
        if (ret->destination == NULL)
          return NULL;
      }
    if (src->options)
      {
        ret->options_len = src->options_len;
        ret->options = calloc (src->options_len + 1, sizeof (*ret->options));
        if (ret->options == NULL)
          return NULL;
        for (size_t i = 0; i < src->options_len; i++)
          {
            if (src->options[i])
              {
                ret->options[i] = strdup (src->options[i]);
                if (ret->options[i] == NULL)
                  return NULL;
              }
          }
      }
    if (src->type)
      {
        ret->type = strdup (src->type);
        if (ret->type == NULL)
          return NULL;
      }
    if (src->uid_mappings)
      {
        ret->uid_mappings_len = src->uid_mappings_len;
        ret->uid_mappings = calloc (src->uid_mappings_len + 1, sizeof (*ret->uid_mappings));
        if (ret->uid_mappings == NULL)
          return NULL;
        for (size_t i = 0; i < src->uid_mappings_len; i++)
          {
            ret->uid_mappings[i] = clone_runtime_spec_schema_defs_id_mapping (src->uid_mappings[i]);
            if (ret->uid_mappings[i] == NULL)
                return NULL;
          }
      }
    if (src->gid_mappings)
      {
        ret->gid_mappings_len = src->gid_mappings_len;
        ret->gid_mappings = calloc (src->gid_mappings_len + 1, sizeof (*ret->gid_mappings));
        if (ret->gid_mappings == NULL)
          return NULL;
        for (size_t i = 0; i < src->gid_mappings_len; i++)
          {
            ret->gid_mappings[i] = clone_runtime_spec_schema_defs_id_mapping (src->gid_mappings[i]);
            if (ret->gid_mappings[i] == NULL)
                return NULL;
          }
      }
    return move_ptr (ret);
}

